'use strict';importScripts('libs.js');

self.Promise = Promise.config({
	longStackTraces: false,
	warnings: false });





self.onmessage = function (msg) {
	var data = msg.data;
	if (data.type === 'setup') {
		self.env = data.args[0];
		System.config(self.env.systemConfig);
		System.import("libs/polyfill.js").
		then(function () {return System.import("src/system-resolve.js");}).
		then(function () {return System.import('systemjs-hot-reloader');}).
		then(function (connect) {
			if (connect instanceof Function && location.protocol !== "https:") {
				connect({
					host: location.protocol + '//' + location.hostname + ':9082',
					entries: [System.resolveSync('src/api/worker/WorkerImpl')] });

			}

			System.import('src/api/worker/WorkerImpl').then(function (workerModule) {
				var initialRandomizerEntropy = data.args[1];
				var browserData = data.args[2];
				if (initialRandomizerEntropy == null || browserData == null) {
					throw new Error("Invalid Worker arguments");
				}
				var workerImpl = new workerModule.WorkerImpl(typeof self !== 'undefined' ? self : null, browserData);
				workerImpl.addEntropy(initialRandomizerEntropy);
				self.postMessage({ id: data.id, type: 'response', value: {} });
			});
		}).
		catch(function (e) {
			self.postMessage({
				id: data.id, type: 'error', error: JSON.stringify({
					name: "Error",
					message: e.message,
					stack: e.stack }) });


		});
	} else {
		throw new Error("worker not yet ready");
	}
};