"use strict";var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}






var isTutanotaDomain = function isTutanotaDomain() {return (

		self.location.hostname.endsWith("tutanota.com") || self.location.hostname.indexOf(".") === -1);};

var urlWithoutQuery = function urlWithoutQuery(urlString) {
	var queryIndex = urlString.indexOf("?");
	return queryIndex !== -1 ? urlString.substring(0, queryIndex) : urlString;
};var


ServiceWorker = function () {









	function ServiceWorker(urlsToCache, caches, cacheName, selfLocation, applicationPaths,
	isTutanotaDomain) {_classCallCheck(this, ServiceWorker);
		this._urlsToCache = urlsToCache;
		this._caches = caches;
		this._cacheName = cacheName;
		this._selfLocation = selfLocation;
		this._possibleRest = selfLocation + "rest";
		this._applicationPaths = applicationPaths;
		this._isTutanotaDomain = isTutanotaDomain;
		this._isBuggyChrome = false;

		if (typeof navigator !== "undefined") {
			var results = navigator.userAgent.match(/Chrome\/([0-9]*)\./);
			if (results != null && results.length > 0) {
				var numberVersion = Number(results[1]);
				if (!isNaN(numberVersion) && numberVersion < 50) {

					console.log("Buggy Chrome version detected. Deferring to no-op sw.js");
					this._isBuggyChrome = true;
				}
			}
		}
	}_createClass(ServiceWorker, [{ key: "respond", value: function respond(

		evt) {
			if (this._isBuggyChrome) {

				return;
			}
			var urlWithoutParams = urlWithoutQuery(evt.request.url);
			if (this._urlsToCache.indexOf(urlWithoutParams) !== -1 || this._isTutanotaDomain && this._selfLocation === urlWithoutParams) {
				evt.respondWith(this._fromCache(urlWithoutParams));
			} else if (this._shouldRedirectToDefaultPage(urlWithoutParams)) {
				evt.respondWith(this._redirectToDefaultPage(evt.request.url));
			}
		} }, { key: "precache", value: function precache()


		{var _this = this;
			return this._caches.open(this._cacheName).then(function (cache) {return (
					_this._addAllToCache(cache, _this._urlsToCache).
					then(function () {return cache.match("index.html");}).
					then(function (r) {
						if (!r) {
							return;
						}

						var clonedResponse = r.clone();
						var bodyPromise = 'body' in clonedResponse ?
						Promise.resolve(clonedResponse.body) :
						clonedResponse.blob();


						return bodyPromise.then(function (body) {return (
								new Response(body, {
									headers: clonedResponse.headers,
									status: clonedResponse.status,
									statusText: clonedResponse.statusText }));}).
						then(function (r) {return cache.put(_this._selfLocation, r);}).then(function () {return cache.delete("index.html");});
					}));});
		} }, { key: "deleteOldCaches", value: function deleteOldCaches()

		{var _this2 = this;
			return this._caches.keys().
			then(function (cacheNames) {return Promise.all(cacheNames.map(function (cacheName) {return (
						cacheName !==
						_this2._cacheName ? caches.delete(cacheName) : Promise.resolve());}));}).
			catch(function (e) {
				console.log("error while deleting old caches", e);
				throw e;
			});
		} }, { key: "_fromCache", value: function _fromCache(

		requestUrl) {
			return this._caches.
			open(this._cacheName).
			then(function (cache) {return cache.match(requestUrl);}).


			then(function (r) {return r || fetch(requestUrl);});
		} }, { key: "_addAllToCache", value: function _addAllToCache(


		cache, urlsToCache) {
			return Promise.all(urlsToCache.map(function (url) {return (
					cache.add(url).
					catch(function (e) {
						console.log("failed to add", url, e);
						throw e;
					}));}));

		} }, { key: "_redirectToDefaultPage", value: function _redirectToDefaultPage(

		url) {
			var hash = url.indexOf('#');
			var withoutBasePath = url.substring(this._selfLocation.length, hash != -1 ? hash : url.length);
			var params = new URLSearchParams({ r: withoutBasePath });
			return Response.redirect(this._selfLocation + "?" + params.toString());
		} }, { key: "_shouldRedirectToDefaultPage", value: function _shouldRedirectToDefaultPage(


		urlWithout) {
			return !urlWithout.startsWith(this._possibleRest) &&
			urlWithout.startsWith(this._selfLocation) &&
			urlWithout !== this._selfLocation &&
			this._applicationPaths.includes(this._getFirstPathComponent(urlWithout));
		} }, { key: "_getFirstPathComponent", value: function _getFirstPathComponent(

		url) {
			var pathElements = url.substring(this._selfLocation.length).split("/");
			return pathElements.length > 0 ? pathElements[0] : "";
		} }]);return ServiceWorker;}();


var init = function init(sw) {
	self.addEventListener("install", function (evt) {
		console.log("SW: being installed");
		evt.waitUntil(sw.precache());
	});
	self.addEventListener('activate', function (event) {
		event.waitUntil(sw.deleteOldCaches().then(function () {return self.clients.claim();}));
	});
	self.addEventListener('fetch', function (evt) {
		sw.respond(evt);
	});
	self.addEventListener("message", function (event) {
		console.log("sw message", event);
		if (event.data === "update") {
			self.skipWaiting();
		}
	});

	self.addEventListener("error", function (_ref) {var error = _ref.error;
		var serializedError = {
			name: error.name,
			message: error.message,
			stack: error.stack,
			data: error.data };

		return self.clients.matchAll().
		then(function (allClients) {return allClients.forEach(function (c) {return c.postMessage({ type: "error", value: serializedError });});});
	});
};


if (typeof env !== "undefined" && env.mode === "Test") {
	module.exports = { ServiceWorker: ServiceWorker };
} else {
	var cacheName = "CODE_CACHE-v" + version();
	var selfLocation = self.location.href.substring(0, self.location.href.indexOf("sw.js"));
	var exclusions = customDomainCacheExclusions();
	var urlsToCache = (isTutanotaDomain() ?
	filesToCache() :
	filesToCache().filter(function (file) {return !exclusions.includes(file);})).
	map(function (file) {return selfLocation + file;});
	var applicationPaths = ["login", "signup", "recover", "mail", "contact", "settings", "search", "contactform", "calendar"];
	var sw = new ServiceWorker(urlsToCache, caches, cacheName, selfLocation, applicationPaths, isTutanotaDomain());
	init(sw);
}

function filesToCache() {return ["index.js", "WorkerBootstrap.js", "index.html", "libs.js", "common.js", "worker.js", "theme.js", "main.js", "main-boot.js", "extra-libs.js", "images/logo-favicon.png", "images/logo-favicon-152.png", "images/logo-favicon-196.png", "images/ionicons.ttf"];}
function version() {return "3.76.10";}
function customDomainCacheExclusions() {return ["index.html", "index.js"];}